---
slug: robossembler-1st-molestone-summary
title: Итоги первого этапа Robossembler
author: Игорь Брылёв
author_title: Team Lead @ Robossembler
author_url: https://gitlab.com/movefasta
author_image_url: https://gitlab.com/uploads/-/system/user/avatar/4249760/avatar.png
tags: [robossembler, milestone, summary]
---

Подошёл к концу первый этап проекта Robossembler. Самое время подвести итоги.

**[Слайды](https://docs.google.com/presentation/d/1F4Che3D7hBMpF03fXbsD2HGUaL9eaKaZ_dz1jKgDhlk/edit?usp=sharing) | [Видео-запись презентации и обсуждения](https://www.youtube.com/watch?v=b4CGrlUm1CM)**

Первоначальный план проекта был выполнен не полностью. Элементная база манипулятора унифицирована не до конца и сейчас понятно, что окончательно будет унифицирована к только к релизу Робосборщика. Сейчас же инженерные решения часто пересматриваются. Тоже самое касается и детального размещения узлов.

Однако, мы начали делать то, что первоначально относили к последущим этапам:

* Проработаны теоретические вопросы управления полностью автоматическим и самовоспроизводящимся производством
* Разработаны конкретные модели приспособлений для манипулятора
* Проведён сравнительный анализ средств визуализации и симуляции
* Подготовлены эскизы фирменного стиля проекта

## Организационные изменения

Сейчас можно уверенно сказать, что команда проекта в значительной степени сформирована конструкторами, технологами, системными инженерами. Найдена кандидатура для программирования под Unreal Engine. Проект на данный момент насчитывает 8 участников, четверо из которых принимают активное участие в разработке.

Команда осваивает git в качестве основного инструмента коллективной разработки, что не является типичным для мира 3D-моделирования. Репозитории размещаются в группе gitlab https://gitlab.com/robossembler

В качестве системы управления знаний создан портал документации, который служит единой точкой входа и местом ключевых публикаций по проекту.
https://robossembler.gitlab.io/docs

Мы регулярно публикуем записи совещаний и образовательные материалы по теме на нашем Youtube-канале.
https://www.youtube.com/channel/UC32Xgbsw9XQlN1QH59pe8HA/videos

## Теория и исследования

Самовоспроизводящаяся фабрика: от простого - к сложному
https://robossembler.gitlab.io/docs/replication

Информационное обеспечение автоматического производства
https://robossembler.gitlab.io/docs/information/information_support

Концепция планировщика производственных операций
https://robossembler.gitlab.io/docs/information/planner

Какие сущности из мира программного обеспечения можно сопоставить с материальными объектами производства
https://robossembler.gitlab.io/docs/analogy

Сравнительное исследование симуляторов робототехники
https://gitlab.com/robossembler/robossembler.gitlab.io/-/issues/1

## Технологии

Описан полный алгоритм сборки робота манипулятора, состоящий на текущий момент из 32-х операций
https://robossembler.gitlab.io/docs/techinstruction

Разработана технология хранения и транспортировки робофабрики
https://robossembler.gitlab.io/docs/autostorage

## Конструкторские решения

Разработаны приспособления для манипулятора 
* сварка https://gitlab.com/robossembler/arm-tools/welding-tool
* пайка https://gitlab.com/robossembler/arm-tools/soldering-tool

## Предстоящие три месяца

Намеченный план на Этап 2 (июнь-август 2021) предполагает:

* Разработкy адаптеров, вспомогательных рабочих столов для стыковки с ЧПУ и другими элементами сборочной линии
* Разработку автоматизированного рабочего места
* Дальнейшее совершенствование и параметризацию технологических карт

При этом нужно дополнительно уделить внимание

* Преодолению разрыва между теорией и практикой
* Уделить больше внимания средствам автоматизации разработки - создание экспертной системы для проектирования САС
* Привлечение дополнительных мозгов для эффективного принятия решений (форумы, чаты), больше публичности
