---
id: glossary
title: Словарь терминов и сокращений
---

**Автоматическая производственная система (АПС)**. Совокупность машин, способная к полностью автоматическому (без присутствия и контроля человека) производству продукции. В проекте рассматриваются АПС достаточно развитые для автоматического воспроизводства на основе исходных объектов той или иной степени готовности, от высокой (модули с защелками) до низкой (мусор, минералы). АПС можно рассматривать как расширенный аналог компьютерной операционной системы, только предназначенный для работы с материей (сохраняя притом информационные способности обычной операционной системы), и, более точно говоря, способным так же работать с энергией (перемещать, видоизменять и пр.), а также с пространственно-временным расположением различных объектов. 

**Автоматическое рабочее место (АРМ)**. Системный объект АПС, посредством которого осуществляются  операции преобразования над объектами. Конструктивно состоит из  рабочего стола и нескольких (2-6) РМ и/или станков. Может механически и электрически объединяться с себе подобными. 

**Автор**. Пользователь, по заданию которого был создан объект. 

**Адаптер**. Объект, принадлежащий одновременно нескольким экосистемам и служащий для взаимодействия между ними. Например, можно представить адаптер между РС и традиционным ЧПУ станком, или между двумя АРМ выполненными по разной технологии, использующими разные протоколы, напряжения, системы координат и т.п.

**Администратор**. Пользователь, имеющий права администрирования АПС.

**Архитектура объекта**. Совокупность описаний (высокого уровня абстракции) объекта, на основе которых может быть разработана его конструкция. Может включать структурированные требования к объекту, структурную и функциональную декомпозицию, а также пространственную компоновку объекта и набор используемых при его работе физических эффектов. 

**Брак**. Объект непригодный для дальнейших операций. Подлежит утилизации или выводу из АПС. Брак выявляется путем действий по измерению свойств объектов, выполняемых в начале, в течение и в конце  каждой операции на которой это представляется возможным.

**Владелец**. Пользователь, владеющий объектом. По умолчанию, автор нового объекта становится его владельцем. Он может продать или передать объект другому пользователю, установить плату за пользование объектом, выставить его на аукцион, прямой или обратный краудфандинг и т.п. Пользователь, повстречавший объект может направить добровольное финансовое вознаграждение его владельцу или автору.

**Воспроизводство**. Производство, развертывание и ввод в работу системных объектов. Может осуществляться в формах роста и размножения клеток.

**Глобальный идентификатор планировщика** - Уникальный идентификатор, присваиваемый новому планировщику при его производстве.

**Действие**. Элементарное взаимодействие АПС с объектом. Различают два вида действий: изменение и измерение. 

**Драйвер**. Устройство контроля текущего состояния системного объекта. Это небольшие коробочки с микроконтроллерами и силовыми ключами. К ним подключены все сенсоры и актюаторы системных объектов. Например, РМ может иметь по отдельному драйверу на каждый привод. 

**Звено робота-манипулятора**. Стандартная часть робота-манипулятора, представляющая собой сборку из двух приводов в общем корпусе. Имеет интерфейсы для объединения нескольких звеньев в манипулятор и другие конструкции.  При последовательном соединении способно передавать сквозь себя следующим звеньям энергию и сигналы управления.

**Задание на создание объекта**. Может исходить как от пользователя, так и от самой АПС. При наличии готового объекта на складе выполнением задания со стороны планировщика будет предоставление объекта. При наличии лишь технологии выдаче должно предшествовать изготовление. При наличии лишь конструкции, изготовлению предшествует разработка технологии. При наличии лишь архитектуры, разработке технологии предшествует конструирование. При отсутствии и архитектуры объекта, выполнение задания начинается с ее разработки.

**Зона АПС**. В каждый момент времени АПС занимает определенную область пространства. Разные области пространства используются АПС неодинаково. В частности, можно выделить рабочую, транспортную и складскую зоны.

**Зона рабочая***. Участок АПС, на котором проводятся техпроцессы, изменяющие объекты.Рабочая зона может состоять из одной или нескольких ячеек, а складская может быть огромной, на тысячи объектов. Рабочая зона может быть оснащена зажимными и прочими устройствами для облегчения работы. 

**Зона складская***. Участок АПС, на котором объекты хранятся. Храниться объекты должны так чтобы на них не летела, скажем, пыль и стружка.

**Зона транспортная***. Участок АПС, служащий для перемещения объектов внутри и между складскими и рабочими зонами, а также их ввода-вывода из АПС во внешний мир. 	Транспортная зона может простираться далеко за пределы рабочей и складской зоны АПС, включая, например, места добычи природных ресурсов и развертывания еще не включенных новых частей АПС. Транспортироваться все изделия должны удобным стандартным образом, чтобы не решать каждый раз эту задачу.

**Изделие** См. Инструмент.

**Измерение** См. Изменение.

**Изменение**. Различают два вида действий: изменение и измерение.  Действия изменения меняют что-либо в объекте (состав, форму, агрегатное состояние, положение...). Они могут сделать из одного объекта несколько (резка, сверление) или наоборот (сборка, сварка), захватить/отпустить объект, перевезти, принять или отдать его на терминале ввода-вывода внешнему миру или другой клетке АПС, добыть из недр земли и т.п. Действия измерения служат для получения информации - о природе, свойствах и геометрии объекта, о его местонахождении, о факте его приема или передачи.   

**Инструмент**. Во время действия изменения над объектами, часть из них выступает в качестве изделий (то, где желательны изменения),  другая часть - в качестве инструментов (в этом процессе им не желательно меняться). Например, при сверлении бруска мы хотим чтобы брусок изменился (появилось отверстие), а сверло должно затупиться как можно меньше. Таким образом, здесь брусок - изделие, а сверло - инструмент. Воздействие инструмента на изделие является полезным, а воздействие изделия на инструмент - паразитным. 
Во время действия измерения все обстоит наоборот, мы хотим чтобы инструмент максимально изменил свое состояние (вольтметр показал напряжение), а изделие осталось неизменным (вольтметр не оказал влияния на процессы в диагностируемой схеме).  Некоторые объекты используются в качестве инструмента редко (какой-нибудь сложный припой для спец. сплавов), некоторые - постоянно (контроллеры, манипуляторы). То что вчера было изделием сегодня может быть инструментом, и наоборот. 

**Клетка**. Структурная единица АПС, способная к автономной от других клеток работе и самовоспроизводству. Каждая клетка работает под управлением собственного планировщика. Между клетками возможен обмен объектами, энергией, информацией. Разбиение АПС на клетки может проходить так чтобы минимизировать транспортные потоки между ними. Для этого каждая клетка может  стремиться к автономности, к «умению всего». Однако в силу неоднородного распределения ископаемых, источников энергии и т.п. межклеточный обмен ресурсами неизбежен. Планирование состава и положения самих клеток АПС и порядка их развертывания может осуществляться пользователями.

**Конструкция объекта**. Совокупность информации об объекте, на основе которой может быть построена технология его изготовления. Конструкция включает в себя информацию о форме, расположении и материале частей объекта (CAD модель), а также совокупность тестов, которые должен проходить объект чтобы быть признан годным и исправным. Для удобства разработки технологии (как автоматического, так и ручного), конструкции следуе описывать не (как это принято сегодня) в виде единственного жесткого варианта, а указывать диапазоны характеристик материалов и важные и неважные участки CAD модели. "Неважный" участок объекта может быть выполнен по другому из технологичеких соображений. Для этого CAD модель может включать в себя пространственные слои, указывающие, например, зоны опционального заполнения материалом и прочую информацию, которая в традиционном производстве задана неявно (Не написано, почему эту деталь именно фрезеруют, но все помнят, что дед фрезеровал - и у него работало. А можно ли ее получить литьем - неизвестно.).   

**Контроллер**. Устройство управления группой системных объектов (например, отдельным АРМ или ММ) на уровне кадров. Это коробочки с быстродействующими микроконтроллерами. Контроллер управляет группой драйверов от которых требуется взаимодействие. 

**Локальный идентификатор объекта** - Идентификатор, присваиваемый каждому объекту, созданному или импортированному извне под управлением данного планировщика. 

**Мобильный манипулятор (ММ)**. Системный объект АПС, посредством которого осуществляются  операции транспортировки над объектами. Конструктивно состоит из  шасси и нескольких (2-6) РМ и/или станков. Может взаимодействовать с себе подобными для перемещения крупных грузов. Может иметь перевозимый комплект сменных захватов и инструментов. Масса ММ оценивается в пределах от 20 до 40 кг.

**Объекты**. Все, над чем АПС может выполнять операции. Объектами являются все виды продукции, их промежуточные состояния и виды сырья. Каждый компонент АПС тоже является объектом, как частный случай продукции АПС (см. Системные объекты). Все остальные объекты относятся к прикладным. Каждый объект как-то попадает в АПС и как-то ее покидает. 

**Операция**. Группа действий, выполняемых АПС над объектом. Операции делятся на операции преобразования, перемещения и ввода-вывода. Каждая операция состоит из одного или более действий, выполняемых последовательно или параллельно. Операция может содержать действия, связанные только с измерением (получением информации об объекте) или еще и с изменением (преобразованием объекта на основе имеющейся информации). В последнем случае, в состав операции до, во время и после действия изменения включены и действия измерения для своевременного отсева брака и предотвращения сбоев и  аварий. Каждой операции соответствует запись в базе данных планировщика, содержащая, набор исходных объектов, алгоритм входного контроля, абстрактный техпроцесс, конкретная программа техпроцесса, набор финальных объектов, алгоритм выходного контроля. Для удобства планирования для операции может быть указана ожидаемая (можно, из опыта) продолжительность, вероятность успешного завершения и прочие вспомогательные сведения.

**Основание РМ**. Часть РМ, основание, на котором монтируются звенья РМ. В его состав входят: 3D печатный корпус, разъёмы, замок (металлическая скоба с отверстиями под штифты), плата разводящая(на разъёмах), плата управления, арматура, кабели, фиксирующий компаунд.

**Пилон**. Интерфейс механического и электрического соединения элементов АРМ (РС, РМ, АС) и надёжной их взаимной фиксации, не снимаемый, обязательный. 

**Планировщик**. Устройство, управляющее клеток АПС путем планирования его операций во времени и пространстве. Это ящички с компьютерами (и жесткими дисками). Планировщик управляет большим количеством контроллеров (АРМ и ММ). У небольшой АПС может быть всего один планировщик. Большие АПС для уменьшения вычислительной сложности уместно разбивать на клетки с отдельными планировщиками (объединенными в сеть и способными к кооперации при необходимости). Планировщики  хранят у себя полный комплект конструкторской и технологической документации на всё (это как бы ДНК АПС) для быстрого к нему доступа, для автономного воспроизводства и на случай выхода некоторых из них из строя. Обычно АПС стремится к тому чтобы иметь несколько планировщиков и управляемых ими клеток. При выходе из строя одного планировщика управление подведомственными ему контроллерами передается другим планировщикам. При производстве нового планировщика наоборот, ему выделяется клетка из хозяйства других планировщиков либо строится заново. 

**Покупатель**.  Пользователь, готовый приобрести некий объект (за деньги или бесплатно).

**Пользователь АПС**. Лицо (физическое или юридическое) имеющее учетную запись в АПС, дающую возможность получать информацию о работе АПС и передавать ей задания путем авторизованного доступа через терминал пользователя. Различные пользователи могут иметь разные привилегии доступа.

**Привод**. Сервомотор-редуктор с динамометром. Состоит из двух половин, способных к относительному вращению. Корпус имеет насечки для охлажения и более качественного сцепления с компаундом, так же имеет штыревые выходы CAN шины для пристыковывания к другим приводам (в том числе приваркой проволочных кабелей).

**Прикладные объекты**. Сбъекты, которые не предназначены для работы в составе АПС. Они представляют собой сырье, полуфабрикаты и продукцию АПС для внешнего мира.

**Продавец**. Пользователь, предлагающий некий объект (за деньги или бесплатно).

**Рабочий стол (РС)**. Основа АРМ. Имеет форму пчелиной соты и 6 пилонов по граням, включает в себя контроллер АРМ.

**Разработка архитектуры объекта**. Процесс создания архитектуры объекта на основе задания и заданного архитектурного стиля. Включает в себя формулировку требований, структурно-функциональную декомпозицию объекта, пространственную компоновку и выбор физических эффектов на основе которых работает объект.  

**Разработка конструкции (конструирование) объекта**. Процесс создания конструкции объекта на основе его архитектуры и заданного конструкторского стиля. Представляет собой построение расширенной CAD модели на основе типовых узлов для реализации физических эффектов (из базы данных таких узлов).  

**Разработка технологии изготовления объекта**. Процесс создания технологии изготовления объекта на основе его конструкции и заданного технологического стиля.

**Размножение**. Форма воспроизводства, при которой системные объекты, созданные клеткой АПС (материнской) передаются в состав новой (дочерней) клетки. По мере наполнения системными объектами дочерняя клетка переходит к самостоятельному росту.

**Репликатор (ядро АПС)**. Минимальный набор системных объектов АПС, способный к самовоспроизводству. Практически ценный репликатор должен быть способен произвести не только себя, но и другие объекты. 

**Робот-манипулятор (РМ)**. Основной инструмент относительного позиционирования объектов при выполнении действий над ними (измерение и изменение одних объектов при помощи других, установка и извлечение из складских и транспортных ячеек, станков). Предполагается имеющим порядка 5-7 степеней свободы. Входит в состав АРМ или ММ и управляется его контроллером. Состоит из основания, звеньев и (?).

**Рост**. Форма воспроизводства, при которой системные объекты, созданные клеткой АПС включаются в его же состав (взамен вышедших из строя, в качестве резервных и дублирующих) в целях поддержания и увеличения его производственных мощностей.

**Системные объекты**. Объекты, из которых состоит или может быть собрана АПС - рабочие места, манипуляторы, складские ячейки и прочее.

**Станок**. Специализированная машина, осуществляющая операции над объектами и не являющаяся РМ. Можно выделить определенные категории станков - закрытые (обрабатываемый объект находится внутри станка), открытые - обрабатывают зону вне себя, порой превосходящую размеры станка, проходные - обрабатываемый объект проходит сквозь станок непрерывно.

**Стиль архитектурный**. Совокупность правил принятия решений (или алгоритм) для автоматической разработки архитектуры объекта. Большой банк архитектурных стилей позволяет разрабатывать одни и те же объекты очень по-разному, расширяя возможносии выполнения заданий.

**Стиль конструкторский**. Совокупность правил принятия решений (или алгоритм) для автоматической разработки конструкции объекта. Большой банк конструкторских стилей позволяет разрабатывать одни и те же объекты очень по-разному (например, какя-нибудь коробочка может быть по-разному сконструирована под трехмерную печать или лазерную резку). 

**Стиль технологический**. Совокупность правил принятия решений (или алгоритм) для автоматической разработки технологии изготовления объекта. Большой банк технологических стилей делает технологические карты многовариантными, оптимизируя использование ресурсов АПС при выполнении задания.

**Терминалы пользователя**. Устройства управления взаимодействием с пользователями. В их роли могут выступать любые компьютеры или телефоны через специальное приложение или веб-интерфейс.

**Технологический процесс (техпроцесс)**. Операция, подразумевающая изменение объектов (кроме перемещения в пространстве), то есть превращение одной группы объектов в другую путем применения к ним одного или нескольких инструментов одновременно. Кроме материальных инструментов определяющих абстрактный техпроцесс (напр. фрезеровка) используется и программа обработки, делающая техпроцесс конкретным (фрезеровка шестеренки такой-то). При одних техпроцессах количество объектов не меняется (окраска, гибка), при других - меняется (нарезка, сборка). Технологический процесс появляется в системе определенным образом (заносится в базу), и, при определенных условиях, удаляется. 

**Техпроцесс абстрактный**. Класс операций по изменению объектов, характеризующийся общим набором материальных инструментов. Например: "Экструзионная 3D печать пластиком", "Токарная ЧПУ обработка металла". Чем больше в системе абстрактных техпроцессов тем она гибче и функциональнее. На практике это значит что конструктор изделия может прописать для него больше альтернативных техпроцессов и планировщику будет легче составить хороший план изготовления изделия.

**Техпроцесс конкретный**. Операция по изменению объектов, для которой указан определенный абстрактный техпроцесс и конкретная программа обработки изделий инструментами.  

**Технология (технологическая карта, технологический маршрут) изготовления объекта**. Граф, состоящий операций, необходимых для изготовления данного объекта, и логических связей между ними. Технология все время заново генерируется планировщиком исходя из конструкции объекта и конкретной ситуации.

**Уникальный идентификатор объекта** - Полностью уникальный идентификатор, присваиваемый каждому объекту и состоящий из двух частей: локального и глобального идентификатора. 

**Утилизация**. Операция по превращению объекта (например, вышедшего из строя РМ) в объекты, пригодные для повторного использования (разборка, переплавка, раствореение и т.п.). 

**Шасси**. Основа мобильного манипулятора. Включает в себя движитель, аккумуляторы и контроллер ММ. Могут быть различных конструкций (колесные, гусеничные, сверхманевренные, шагающие). В некоторых конструкциях РМ могут использоваться в качестве лап.

**Экосистема**. Множество объектов, способных стыковаться и взаимодействовать непосредственно между собой. Разные поколения АПС или ее фрагменты созданные разными разработчиками в разное время могут принадлежать к разным экосистемам и требовать адаптеров для совместной работы.

**Ядро АПС**. См. Репликатор.
