---
id: mining
title: Обмен веществ, деление и рост автоматических производственных систем
---
Механизм роста автоматических производсвтенных систем (АПС) и способ добычи сырья из окружающей среды взаимосвязаны. Например, ей необходимо опираться на грунт и в то же время добывать его. Ей нужно строить свои клетки из окружающего материала и где-то размещать их, так как будучи, в основном, пустотелыми, они занимают на порядок больше места, чем извлеченный объем грунта. Ей нужно избегать попадания окружающего материала в производственные объемы и в то же время расширяться. Ей нужно уметь справляться с такими ситуациями как обвал, прорыв грунтовых вод или действовать на морском дне. Наконец, ей нужно быть совместимой с порядком пользования недрами и морским дном установленным государственными и международными правовыми нормами.

В свою очередь, это влияет на конструкцию элементарной клетки АПС. В природе изоляция внутренней среды от внейшней в процессе репликации нашла свое воплощение в механизме деления клеток. При делении так или иначе клетка строит внутри себя двойную перегородку, потом перегородки отсоединяются одна от другой. Это не слишком сложно повторить - перегородить цех двойной стеной, а затем объявить обе половинки новыми клетками. Однако, делению должен предшествовать рост, иначе каждое последующее поколение клеток будет все меньше и меньше.

Рост предполагает не только увеличение клетки при сохранении ее герметичности, но и раздвигание мешающих препятствий в окружающей среде, а также разрыхление крупных и твердых препятствий, которые нельзя подвинуть.
Рост в атмосфере или воде требует одной лишь герметичности, а вот в толще земли, особенно в скалистых породах он требует предварительного труда по освобождению некоторого объема. В нашем случае этот объем так или иначе нужно освобождать, ведь он служит сырьем для новых клеток и полезной продукции АПС. В этом отличие робофабрики от растения - для растений характерен рост корней, но они лишь в небольшой степени извлекают объемы почвы, в основном, впитывая воду и растворимые в ней вещества. Сама же основа грунта остается на месте, служа опорой растению, и лишь слегка раздвигается при росте корней.

Тем не менее, у корней есть чему поучиться. В Сети есть немало красивых видео прорастания семян. Корень в целом растет следующим образом: на его кончике есть зона активного деления, продуцирующая два типа клеток. Одни оказываются снаружи, в направлении роста, разрушаются и выделают вещества, размягчающие и смазывающие частички почвы. Другие - позади конуса роста. Эти последние клетки впитывают воду и набухают, продвигая зону деления вперед, через смазанную слизью область почвы. Таким образом, для подземного роста характерно использование предварительного ослабления сдвигаемых пород и гидравлического домкрата, продвигающего клетки сквозь них.

В случае робофабрики смачивание логично заменить разделением на небольшие кусочки и использованием в производственных процессах. В этом случае, рано или поздно, поблизости окажется пустота и будет нужен не такой уж мощный механизм, чтобы ее занять. 

Однако, остается проблема того, чтобы все это происходило герметично. Если клетка занимает пустоты путем роста, а при определенном размере делится, то ее наружный слой изменяет свою геометрию, как за счет встраивания новых блоков, так и за счет трансформации уже имеющихся. По сути, достаточно двух операций: силовое растяжение-сокращение блока вдвое, и экранирование соседнего с ним участка. Рассмотрим это подробнее.

Если мы говорим о клетке в виде прямоугольного параллелепипеда, то у нее есть три возможных направления роста: вверх, вниз и в сторону. Рассмотрим клетку, состоящую из кубических блоков стандартной формы, произвольной ширины и длины и высотой в пять блоков. Нижний слой блоков образует пол, три слоя посередине образуют стены и один слой образует потолок. Стены высотой в три блока позволяют перемещаться мобильному манипулятору, который несколько больше одного блока и может взять и перевезти любой блок пола, стен или потолка. Эти блоки производятся в клетке и используются для роста и деления.

В любом случае, иногда блоки, находящиеся на границе клетки с окружающей средой будут нуждаться в замене. Если стенка удет однослойной, то чтобы при замене блока не образовывалась брешь, соседние блоки должны прикрыть ее шторками. Но это может быть ненадежным, особенно на ребрах и углах прямоугольной фабрики, к угловым элементам может просто не быть доступа. Иное дело - двуслойная стенка. Тогда, при условии что блоки могут контролируемо сдвигаться друг относительно друга (с помощью мобильного манипулятора или собственных приводов), можно заделывать брешь изнутри, сдвигая блоки и выталкивая поврежденные наружу. Для этого защелки между блоками должны быть устроены таким образом, чтобы исправный блок в любом случае мог отсоединиться от поврежденного. Причем возможно два режима работы с блоками - их замена (для этого геометрия и механика стенок должна позволять забрать произвольный блок вовнутрь) или замещение (старый блок просто вываливается в окружающую среду). По-видимому, и замена и замещение блоков реализуемы при любой толщине стенок, но толщина в два блока для стен, пола и потолка клетки представляется оптимумом - можно отказаться от шторок, усложняющих блоки и в то же время не совершать слишком много движений для замены блока. При этом все эти многочисленные блоки могут выполнять и дополнительные полезные функции,в основном, видимо, хранения - хранить коробки с объектами, запасать энергию, служить блоками памяти.

Самым простым случаем является рост и деление вверх. Представим, что самый средний слой может вытягиваться в высоту, например, состоит из домкратов или подобных механизмов. Эти механизмы размещены на этой высоте везде, во всех внешних и внутренних стенах и колоннах. Так каждому домкрату нужно поднимать вес не более чем десятка блоков, а часто много меньше. Если они одновременно вытянуться вверх, клетка станет выше на один блок. Предполагается, что домкраты, особенно на внешних стенах и углах, имеют раздвижные шторки, позволяющие сохранять герметичность внутреннего объема при растяжении. Пусть это будет даже и не полная герметичность, но все же лучше, чем ничего. Хорошо, если она будет полной, но на случай если это не так, стоит предусмотреть возможность работы клетки при условии что внутри нее оказывается та же среда, что и вокруг - воздух, вакуум, вода... а процессы требующие иной среды и хранение объектов осуществляются в герметичных контейнерах. (Не знаю, пройдут ли когда-либо подобные трюки с магмой или от нее все же лучше как следует отгораживаться.) Тогда не придется делать шторки слишком прочными чтобы противостоять разности давлений, и повреждения оболочки не будут вызывать порчи всей клетки целиком - ведь отремонтировать пробоину в оболочке клетки намного дешевле, чем вырастить новую клетку.

После того, как домкраты сделали клетку высокой, один или несколько из них могут снова сократиться (крыша и верхняя часть стен при этом висит на остальных вытянутых домкратах), при этом его шторки продолжают закрывать двойную поверхность. На сократившиеся домкраты могут быть установлены новые блоки и они подпирают их принимая на себя свою часть нагрузки. Тогда сокращаются другие домкраты и на них тоже устанавливаются очередные блоки. Так происходит до тех пор, пока все домкраты не окажутся сокращенными и нагруженными дополнительным блоком. Теперь можно свернуть шторки. Наша клетка стала на один ярус блоков выше, ни на мгновение не утратив герметичности. Теперь потолок отделяют от пола стены высотой в четыре блока. Можно повторить весь процесс и вырастить стены еще выше, можно присоединять блоки сбоку и снизу к растущим стенам, строя послойно новый потолок, взамен "уехавшего" вверх. Так постепенно из одной клетки образуются две: нижняя и верхняя. Крыша старой материнской клетки досталась верхней, пол - нижней. А пол верхней и крыша нижней были построены снизу в ходе роста. Остается запустить часть мобильных манипуляторов из нижней клетки в верхнюю (если они не были встроены в нее раньше) и обе клетки могут повторять процесс деления покуда силы домкратов нижних клеток будет хватать на подъем вышестоящих этажей, и покуда позволит прочность их стенок.

Аналогично происходит и рост вниз, при этом подразумевается, что под клеткой уже выработана полость глубиной не менее чем в один блок, и тогда она висит на вышестоящих и боковых соседях, а домкраты вместо подъема крыши опускают пол и нижнюю часть стен.

Рост в сторону несколько отличается, так как ширина клетки может быть очень большой. Поэтому домкраты находятся не посередине, а по периметру крыши и пола, позволяя сдвинуть любую из стенок в определенном направлении и застроить блоками образовывашийся пустой поясок, прикрытый шторками от окружающей среды. 
На пересечении рядов блоков-домкратов находятся элементы, которые не выполняют силовой функции, зато способны выпускать шторки в двух перпендикулярных направлениях, позволяя клетке выстраивать гибкую тактику роста (то по Х, то по Y) в зависимости от ситуации.

Если АПС осуществляет рост глубоко в недра земли, то может быть резонным заполнять толщу пород не сплошным объемом клеток, а решеткой, используя оставшийся массив горных пород как каркас. Она может вести себя подобно грибнице, строя подземную сеть для сбора ресурсов, прорывающуюся на поверхность в различных новых местах. Таким образом, поземный рост может понадобится не только вниз, но и в сторону и вверх. Поэтому, как пол, так и потолок, так и стены клетки должны быть оборудованы средствами добычи окружающей материи (и, одновременно, очистки от нее пространства для последующего роста).

Несмотря на то, что известно немало способов разрушения горных пород - химические, тепловые, мехнические и т.д., не все их них удобны для АПС. Например, лишайники выделяют кислоты, чтобы травить камни, на которых обитают. Можно использовать на границе с окружающей средой взрывчатку или крайне агрессивные вещества вроде пентафтористого брома чтобы травить практически все что угодно, сознательно мирясь с разрушением крайнего слоя клеток, как это делают корни растений. Но представляются более удобными более "тихие" методы, не портящие сами клетки и их содержимое. Например, откалывание небольших (скажем, в половину линейного размера блока) кусков породы и помещение их в "пищеварительные вакуоли" - герметичные камеры (размером с блок) для химического или физического "переваривания". Это уместно, по крайней мере, на первых порах, когда робофабрика требуень отладки и инспекции со стороны людей. Если же дело зайдет далеко, то на первый план, как и в природе может выйти не проблема отладки, а проблема борьбы с паразитами и тогда вслед за лишайниками и грибами робофабрика может пойти по принципу "чем ужасней вещества выделяются вокруг, тем меньше проблем с чужаками" - и расщеплять окружающий слой материи "робокислотами" и "робоантибиотиками".

Отколоть выступающий кусок породы не очень сложно, а вот грызть гранить на ровной стене или в углу - же труднее. Поэтому, во-первых, лучше не создавать резких углов, вырабатывая породу округлыми контурами - например, по простейшему алгоритму - откусывая следующим кусок породы в точке с минимальным евклидовым расстоянием до клеточной стенки. Во-вторых, нужен инструмент, способный при необходимости откусывать и в углу. В-третьих, ключ к эффективной разработке недр - в рекуперации энергии, потраченной на обработку пород, а рекуперировать энергию, потраченную именно на откалывание от массива - затруднительно. Поэтому нужно делать разрез породы как можно более тонким, в идеале - в несколько атомов шириной, а основную тонкую обработку, восстановление оксидов, разделение элементов и прочее вести уже в "вакуолях". 

Всем этим требованиям по-видимому удовлетворяют инструменты, способные делать конические надрезы пород под различным углом. По принципу действия оним могут быть самыми разными - сверлящими, пилящими, лазерными, электрогидравлическими, гидроабразивными, плазмоструйными и т.д. и могут сменяться в зависимости от конкретной встреченной породы. Надрез может сочетаться с захватом образца породы для его дальнейшей транспортировки внурь клетки.

Важнейшим моментом является, конечно, способ переработки ископаемых. Можно рассматривать их как случайную непредсказуемую смесь веществ. Это позволяет объединить их в одну группу с такими объектами как мусор (импортированный из традиционной экономики), а также бракованные изделия и вышедшие из строя блоки самой робофабрики. Все это представляет собой смесь веществ, которые должны быть превращены в чистые, пригодные для технологического использования или продажи вещества и притом с минимальными затратами энергии. 

При этом можно выделить несколько групп веществ, способных взаимно превращаться друг в друга с поглощеием или выделением энергии. Как правило, превращения с поглощением энергии создают более дорогой материал (например, железо дороже продуктов его горения - оксидов). Но связь эта не стоь уж однозначна. И это позволяет выстроить энергетически и экономически целесообразные графы преобразования веществ.

* **Металлы**. Чистые металлы могут встретиться скорее в техническом мусоре, нежели в минералах. Их целесообразно разделять и очищать, восстанавливать из оксидов, несмотря на энергозатратность этого - ценность металлов (особенно редких и рассеянных) будь то для внутреннео пользования или продажи, превосходит ценность энергии, затрачиваемой на их востановление. Хотя в исключительных ситуациях (например, на Луне) металлы могут оказаться важным топливом.
* **Ge,As,Se,B,P,Sb,Te,I** в чистом виде обладают большой ценностью, удобны и безопасны в хранении. Поэтому накапливаются на равных правах с металлами.
* **Смешанные оксиды** (металлов, а также кремния), карбонаты, соединения серы - основа минерального сырья. Восстанавливаются до элементов и разделяются.
* **Кремний**. При высокой степени очистки - весьма дорогой материал. Однако, поскольку этот элемент один из самых распространенных в земной коре, может сложиться его избыток. Поэтому кремний, который не получается очистить для нужд полупроводниковой промышленности, можно повторно окислить с большим выделением энергии. При этом можно не только рекуперировать энергию, но и получить дорогой и ценный материал - кварц, причем в форме заданных изделий - оптики, химической посуды, электроники и т.д. 
* **Алюминий**. Аналогично кремнию - очень распространенный элемент. При превышении добычи над потребностью может быть конвертирован с большим выделением энергии в ценный материал - сапфир. Превращение песка, глины, гранита в кварц и сапфир с выделением редких элементов при должной организации может осуществляться с почти полной рекуперацией энергии - оторвали кислород, потратили энергию, присоединили - вернули. Однако упорядоченность, и, соответственно, ценность материала при этом возрастает во много раз. Взять хотя бы выделение урана из гранита: при рекуперации энергии, затрачиваемой на разложение оксидов, составляющих гранит, это само по себе становится весьма выгодным даже при ничтожных концентрациях урана. 
* **Галогены (кроме йода)** - в основном, могут поступать с мусором. Хранить и продавать их в элементарном виде затруднительно и опасно. Поэтому их избыток имеет смысл комбинировать с другими доступными веществами в дорогие и притом безопасные химические продукты. Так как алюминий, получаемый из глин не является дефицитным для робофабрики, можно превращать хлор и бром соответственно в безводные хлорид и бромид алюминия - важные и дорогие катализаторы в химической промышленности, удобные в хранении и безопасные. Аналогично, фтор можно комбинировать с общедоступным (из известняка) кальцием, формируя изделия из CaF2 - дорогого материала УФ и ИК оптики. 
* **Углеводороды, уголь, органические и элементоорганические соединения** - могут быть в крайнем случае сожжены в энергетичеких целях, но гораздо более выгодно их использование в качестве сыпрья для органического синтеза, например, углеводов или аминокислот, а со временем - все более сложных и ценных соединений - лекарств, полимеров, материалов органической электроники.  

Таким образом, при наличии подвода энергии извне (солнечная, электрическая) не предполагается образования каких-либо отходов, наоборот, АПС может активно поглощать мусор и отходы извне. При работе на топливе неизбежно будет образовываться большое количество отходов,  с которыми энергетически не выгодно работать, которые, впрочем, могут образовываться в востребованных рынком формах. При использовании ядерного топлива обыкновенные химические отходы не образуются (выгодно их перерабатывать в продукты), зато образуется небольшое количесто ядерных.

В каждом регионе есть "Список общераспространенных полезных ископаемых", куда входят обычно глина, песок, доломиты, известняк, мергель и прочее минеральное сырье низкого качества (непригодное для добычи типичнызх ископаемых). Входящие в него ископаемые могут облагаться нулевым налогом при получении лицензии на их добычу. Однако само получение лицензии происходит через аукцион, надо соблюдать определенные правила эксплуатации месторождения и отчитываться о добытых объемах. В целом, в отечественном законодательстве просматривается определенная бесправность пользователей недр перед контролирующими инстанциями, поэтому при получении собственниками АПС сверхприбыли они могут быть легко обложены сверхналогом. Возможно, добычу ископаемых надо согласовывать на политическом уровне, когда государство получает не деньги, а стратегически полезный эффект, например, устранение пустыни, расширение территории за счет искусственных островов, создание пригодной для освоения местности в важных, но труднодоступных регионах, создание барьеров между собой и агрессивным соседом и т.п. 

Например, АПС может в короткие сроки создавать инфраструктуру и коммуникации для новых городов в отдаленных районах и там же предоставлять выгодные рабочие места, связанные с разработкой новых продуктов для автоматического производства. Собственно, жилые и рабочие помещения для людей могут появляться как специализированные клетки АПС, подобно тому как разные организмы создают благоприятные условия для своих симбионтов.

Кроме добычи объектов из природы, АПС, конечно, может приобретать их и продавать. Для этого необходимы упаковка и транспортировка. Удобным и популярным способом для этого является стандартный ISO контейнер. Особенно удобны контейнеры с дверцами с двух сторон. Так как производительность АПС предполагается весьма большой, имеет смысл рассмореть вариант сквозных тоннелей для грузового и железнодорожного транспорта, где прямо на ходу контейнеры снимаются и устанавливаются. Снятый контейнер проходит определенный маршрут на котором он разгружается и загружается продукцией. При интервале между машинами в 100 метров и скорости в 60 км/час, каждые 6 секунд один контейнер должен разгружаться (а другой - загружаться). Для этого можно использовать систему "контейнер в контейнере", при которой внутренний контейнер выдвигается из стандартного и отправляется по внутренней транспортной сети на подробную разгрузку. Эта разгрузка может идти уже долго, например 6000 секунд (= 100 минут) при использовании 1000 параллельных участков (например, по одному в каждой клетке). То же касается и загрузки. При этом, в каждой из этих клеток может находиься условно по 10 производственных участков финальной сборки, каждый из которых за те же 100 минут производит продукции на 1/10 контейнера.

При объеме 20-футового контейнера в 33 м3, одна десятая составит 3.3 м3. Это соответствует производительности 33 литра в минуту или 0.5 литра в секунду, которую для большинства продуктов (если не брать пенопласт и воздушные шары) достичь нелегко. Таким образом, один погрузочно-разгрузочный автомобильный тоннель уверенно может обслуживать тысячи клеток, а железнодорожный - десятки тысяч, так как интервалы между контейнерами на платформах практически отсутствуют. Конечно, сначала можно использовать тоннели не на полную загрузку, например не круглосуточно и не каждый день. 

Так или иначе, вырисовывается макроскопическая единица коммерческой АПС, назовем ее условно сегментом, которая обслуживается одним или несколькими (для резервирования) транспортными тоннелями. Она включает в себя от сотен до десятков тысяч универсальных производственных клеток и определенные органы из специализированных клеток - транспортных (быстро перемещающих и обрабатывающих контейнеры, обеспечивающих их загрузку-выгрузку на транспорт). У такого сегмента могут быть и другие специализированные органы: электростанция, система дальней связи, вычислительный центр и т.п.

Требование работы с ISO-контейнерами может быть использовано для задания основных размеров и параметров грузоподъемности клеток. Некоторые виды продукции АПС для продажи на рынке (например, электростанции) могут быть изготовлены в формате контейнеров, некоторые - могут складироваться внутрь контейнеров. Блоки АПС также могут перевозиться в отдаленные регионы для развертывания внутри контейнеров. Размеры клеток и транпортных систем должны позволять работать с контейнерами.

В то же время, необязательно тащить контейнер в каждую клетку. Из него может быть вытащен соединенный конкгломерат стандартных коробок и разъехаться по клеткам на обработку.

Самую большую длину (13716 мм) и высоту (2896 мм) имеют 45-футовые контейнеры «High-Cube». Ширина всех контейнеров стандартна и составляет 2438 мм. Максимальный брутто вес самого тяжелого контейнера при полной загрузке по стандарту не должен превышать 30848 кг. Минимальная ширина дверного проема - 2286 мм, минимальная высота - 2280 мм. Минимальная внутренняя длина составляет 5758 мм среди 20-футовых и 11998 мм среди 40-футовых контейнеров.

Строго говоря, блоки из которых строятся клетки АПС не обязаны быть кубическими. Однако, при этом достигается максимальное среди параллелепипедов отношение объема к площади и стандартизируются процедуры работы с горизонтальными и вертикальными поверхностями, собранными из блоков. Поэтому примем кубический блок за основу.

Конкретная конструкция клеточной стенки из блоков должна соответствовать следующим требованиям:

* **Возможность роста** вверх, вниз и в стороны
* **Возможность деления** на две полностью автономные, спосбные к развитию клетки
* **Возможность обмена** мобильными роботами, контейнерами, коробками, блоками, энергией, информацией с соседними клетками
* **Возможность добычи ресурсов** (материальных или энергетических) с любой стороны клетки и их подачи в клетку без нарушения ее герметичности
* **Возможность управления теплопроводностью** для контролируемого отвода и подвода тепла с нужных сторон клетки 
* **Возможность очистки пространства с любой стороны клетки для деления в эту сторону
* **Обеспечение устойчивой опоры на грунт** для соприкасающихся с ним клеток
* **Статическая грузоподъемность** позволяющая выдерживать вес контейнеров и вышестоящих этажей 
* **Динамическая грузоподъемность** позволяющая поднимать и опускать как минимум один этаж силами другого в процессе деления.
* **Ремонтопригодность** - возможность замены любого блока, в том числе на внешней стороне стен, пола и потолка.
* **Непрерывная герметичность** клетки как во время ее обычной работы, так и во время роста и деления, входа и выхода мобильных роботов, при выходе из строя любого единичного блока, в процессе замены любого блока.
* **Быстрое восстановление герметичности** в случае ее нарушения
* **Возможность мониторинга** ситуации вокруг клетки
* **Обеспечение доступа мобильных манипуляторов**, то есть достаточная ширина и высота проходов, и возожность дотянуться им до любой нужной точки
* **Достаточная ширина и высота прохода для работы с контейнерами**
* **Достаточная длина для работы с контейнерами**
* **Возможность перевозки групп блоков в контейнерах**
* **Возможность размещеняи заданного числа рабочих машин**, состоящих из заданного числа блоков
* **Возможность размещения и удобного доступа к заданному числу складских мест** для хранения блоков и объектов

Анализ многобразных способов расположения блоков показал, что одним из самых экономичных и технически простых спосбов обеспечения непрерывной и быстро воссттанавливающейся герметичности являестя испольование двуслойной клеточной стенки. При этом внутренний слой представляет собой решетку блочного силового каркаса, пустоты в которой заполнены складскими блоками, а внешний слой состоит из блоков-трансформеров и блоков взаимодействия с внешней средой (добыча ресурсов, энергии и пр.). Блок-трансформер спосбоен вытягиваться по одной из трех осей (поочередно), тем самым прикрывая соседнюю пустоту (обеспечивая герметичность). Закрепившись вытянутым концом на другном блоке и подтянув заднюю часть такой блок способен перемещаться. Это играет немалую роль в обеспечени заменяемости блоков наружной стенки. Согласованные действия блоков-трансформеров позволяют оперативно заделывать аварийные места, перемещать обычные блоки и вышедшие из строя блоки-трансформеры в любых направлениях по клеточной стенке, а также между внутренней и наружной ее сторонами.

Ввиджу того, что блоки-трансформеры относительно сложны, они не рассматриваюстя как опорные (хотя могут способствовать опоре). Поэтому между работающими клетками они могли бы не использоваться, а только на границе с внешней средой, где и нужна герметичность. Но, учитывая большие размеры клеток, они могут быть подвержены механическим и тепловым деформациям, погрешностям изготовления и сборки. Поэтому между ними нужен компенсирующий геометрические искажения слой. Кроме того, внезапно вышедшая из строя клетка, даже не граничащая со внешней средой, может представлять опасность для соседних (например, в виду утечки технологических веществ и материалов). Поэтому геметизирующие блоки-трансформеры все же должны находиться и между клетками, образуя двойной слой - по одному слою, относящемуся к каждой клетке. Для обеспечения же опоры и силовой связи (способной компенсировать деформации и демпфировать сотрясения) кое-где среди блоков-трансформеров используются блоки-домкраты, расположенные на полу и потолке на одной линии с опорными колоннами клеток и на их стенках.

Таким образом, клетка состоит из трех уровней - пол, цех, крыша. Над крышей (толщина в один блок) и под полом (толщина в один блок) располагаются по одному слою блоков-трансформеров, пронизанные сеткой блоков-домкратов. Теперь необходимо определить количество блоков в слое, образующем цех. Оно должно обеспечивать свободный проход наиболее высоких контейнеров. Так как высота их составляет 2896 мм, то высота потолка цеха может быть равной 3 метра или более. 3 метра это достаточно удобно и для прохода человека в случае такой необходимости.

Контейнеры могут перемещаться по прямой, опираясь на специальные блоки, способные слега приподнять и сдвинуть (на сантиметры) груз с большой силой за один такт.

Количество блоков, укладывающихся в эту длину можно определить исходя из следующих соображений: 

* Возможность растяжения на один блок домкратов и трансформеров без потери герметичности внешней стенки. Если домкрат растягивается на 100%, то он для этого достаточно одного их слоя. Но сделать такой домкрат, да еще герметичный - трудно. Поэтому примем растяжение на 50%. Таких слоев достаточно двух.
* Максимальное отношение числа рабочих блоков к числу служебных (домкраты, трансформеры и прочее)
* Максимальный абсолютный размер блока (для обеспечения грузоподъемности при минимуме внутренних соединений, удобства конструирования и изготовления при существующем уровне технологий), минимизации числа поднимаемых блоков на один домкрат.
* Домкраты могут расширяться и сужаться только в одну сторону
* Домкраты должны быть удобно доступны для замены изнутри в случае их выхода из строя в любом положении. То есть, их не должны загораживать другие блоки.
* Путь изнутри к блокам обмена с внейшней средой должен лежать не через домкраты. Следовательно, блоки обмена с внешней средой на стенах размещаются между домкратами. Следовательно, блоки, непосредственно работающие с внешней средой должны находиться непосредственно за ними. Следовательно, блоки-трансформеры на стенах должны находиться за домкратами.
* Под домкратами и над домкратами должны быть мощные блоки, способные нести и передавать нагрузку. Нагрузка не должна приходиться на домкраты с нерабочей стороны. Поэтому вертикальные домкраты не могут быть встроены в потолок и пол (что было бы удобно для экономии места) и должны находиься в стенках. 
* Возможность замены единичного вышедшего из строя блока-трансформера не должна зависеть от работоспособности его приводов
* Если блоки-трансформеры и рабочие блоки внешней оболочки будут чередоваться в шахматном порядке. Тогда при замене или разрушении рабочего блока образовавшуюся брешь во внешней стенке может прикрыть любая из двух пар блоков-трансформеров, окружающих его с противоположных сторон. Если они будут выстроены полосами, то лишь одна пара блоков-трансформеров может прикрыть брешь, зато они могут быть однонаправленными. Впрочем, однонаправленность трансформации блоков сильно затруднит замену угловых блоков, поэтому на нее сильно рассчитывать не стоит. Таким образом, каждый рабочий блок внешней оолочки должен бытьокружен слоем как минимум в один блок-трансформер.
* Между тем, для вышедших из строя блоков, не поддающихся перемещению штатными средствами, предусмотрена замена выталкиванием, когда изнутри поступает новый блок, а старый просто вываливается в окружающую среду (так происходит, например, линька животных и отшелушивание верхних слоев кожи). Заклинившие и залипшие на поверхности дефектные блоки и посторонние предметы можно разрушать и удалять при помощи блоков добычи ресурсов (как, например, животные чешутся зубами и лапами).
* Расстояние между сторонами шестигранного роботизированного рабочего стола составлят 375 мм.

Рассматриваемый подход позволяет работать со стенками различной высоты. Но не все из них удобны. Например:

* 1 блок высотой 3 метра - Сложная замена и транспорт блоков. Очень мало рабочих блоков по сравнению со служебными. Нет места для мобильного манипулятора, использутся самоходные блоки. Общая высота клетки 15 метров, из которых "по делу" только три. Блок не лезет в контейнер. Домкраты должны растягиваться на 100% и занимают всю высоту стен. В общем - не хорошо. 
* 2 блока высотой 1.5 метра. Общая высота клетки 9 метров. В контейнер влезает три блока. Домкраты должны растягиваться на 50% и занимают всю высоту стен. Соответственно, за ними нельзя разместить добывающие блоки и они не могут быть размещены в шахматном порядке, а могут быть размещены в виде колонн по 4 блока чередующихся с колоннами блоков-трансформеров.
* 3 блока высотой 1 метр - все еще тяжеловато мобильному манипулятору переносить блоки размером с него. Он, конечно, должен уметь перенести себе подобного, но он легкий, а блоки, особенно несущие силовую нагрузку могут быть очень плотными. Общая высота клетки 7 метров. В контейнер влезает 20 блоков. Добывающие блоки можно размещать колоннами по 5 (в высоту) через одну. Горизонтальными линиями, по-видимому, их вообще не выгодно размещать. Хранение блоков, требующих прямого доступа (без перекладывания других) организовывать неудобно.
* 4 блока высотой 750 мм. Общая высота клетки 6 метров. У стенок с четным числом блоков получается колонн с добывающими блоками меньше, чем с блоками-трансформерами и располоены они неравномерно, несимметрично что затрудняет автоматизацию проектирования. Поэтому предпочтение можно отдать стенкам с нечетным числом блоков.
* 5 блоков высотой 600 мм. Общая высота клетки 5.4 метра. При ширине проезда мобильного манипулятора в три блока удобно организовывать хранение. Внутрь помещаются компоненты АРМ.
* 6 блоков высотой 500 мм. Общая высота клетки 5 метров. 
* 7 блоков высотой 430 мм. Общая высота клетки 4.73 метра. В контейнер влезает 325 блоков. Размер блока примерно совпадает с длинной осью шестигранника рабочего стола АРМ. Но внутрь блока он уже не помещается.
* 8 блоков высотой 375 мм - совпадает с шагом шестигранников АРМ, но только в одном направлении. Общая высота клетки 4.5 метров. Меньше этого размера блоки может быть весьма трудно изготовить при существующем уровне техники и в них явно не будут помещаться спроектированные компоненты АРМ.
* 10 блоков высотой 300 мм - Общая высота клетки 4.2 метров.
* 12 блоков высотой 250 мм. Общая высота клетки 4 метра.
* 15 блоков высотой 200 мм. Общая высота клетки 3.8 метров. В контейнер влезает 3388 блоков.
* 20 блоков высотой 150 мм. Общая высота клетки 3.6 метра.
* 25 блоков высотой 120 мм. Общая высота клетки 3.48 метра.
* 30 блоков высотой 100 мм. Общая высота клетки 3.4 метра.

Таким образом, всей совокупности требований хорошо отвечает лишь высота стенки цеха в 5 блоков размером по 600 мм (этот размер можно корректировать в большую сторону до 750 мм максимум (иначе в 20-футовый ISO контейнер дял перевозки они будуть помещаться слоями не 3 х 3 а 2 х 2)) Тогда можно определить и остальные геометрические параметры клетки:

* Ширина коридора для работы с контейнерами: 3000 мм (5 блоков)
* Ширина коридора для проезда мобильного манипулятора: 1800 мм (3 блока). 
* Ширина проезда для мобильного манипулятора в плоскости: не более 1800х1800 мм (3 блока).
* Толщина внешней стенки: 1200 мм (два блока)
* Размер блока, перевозимого мобильным манипулятором: 600 мм.
* Длина места под самый большой (45-футовый) контейнер с учетом места для открывания дверей: 15000 мм (25 блоков).
* Площадь грани блока 0.36 м2.
* Максимальное давление груженого контейнера на пол клетки: 2000 кг на м2. Отсюда минимальная грузоподъемность опорного блока контейнера: 720 кг.
* Нагрузка на колонну/домкрат для одного этажа: 72 блока
* Нагрузка на колонну/домкрат для N этажей: 72*(2N+1), например для 10 этажей это 1512 блоков. Для 100 этажей - 14472.Отношение веса поднимаемого современным домкратом к его весу составляет около 5000. В то же время, большинство блоков довольно легкие. Тем не менее, без дополнительных опор высота фабрики ограничена примерно 30 этажами. При построении вглубь земной коры модно обойти это ограничение используя участки и мостики породы в качестве опоры, то есть не сплошную застройку, а сетчатую.

Надо составиь паттерны структуры и поведения групп блоков. Группы блоков - это структурные единицы из которых строится клетка. Трасса, складское место, машинное место - это группы блоков. Между группами находятся стенки или проезды, снаружи (крайние) группы окружены оболочкой. Группа имеет размер 3х3 метра по горизонтали, а в высоту включает в себя все слои блоков данной клетки.

Разновидности групп: 

0. **трасса ММ**
1. **трасса контейнера** 
2. **зона деления по X**
3. **зона деления по Y**
4. **зона деления по X и Y**
5. **машинная зона**
6. **склад**
7. **подъемник межэтажный**
8. **гараж ММ**
9. **рабочий порт**

Разновидности стенок

0. **свободный проезд**
1. **створка ворот**
2. **внешняя стенка**

